## fwbuilder-6.0.0_rc1_p20230723-8013c00e.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9"
    CACHE STRING "Minimum macOS deployment version"
)

find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
endif()

project(firewallbuilder LANGUAGES CXX C)

### Version variables and include file

include(VERSION)
configure_file("${CMAKE_SOURCE_DIR}/src/version.h.in" "${CMAKE_BINARY_DIR}/src/version.h" @ONLY)
include_directories(${CMAKE_BINARY_DIR}/src)

### Build type

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: Debug or Release."
        FORCE)
endif()
include( CTest )

### Dependencies

option(UseQt6 "Use Qt6" OFF)
if (UseQt6)
    find_package(Qt6 COMPONENTS Widgets Network PrintSupport REQUIRED)
else()
    find_package(Qt5Widgets REQUIRED)
    find_package(Qt5Network REQUIRED)
    find_package(Qt5PrintSupport REQUIRED)
endif()

find_package(LibXml2 REQUIRED)
find_package(LibXslt REQUIRED)

find_package(NetSNMP)
if(NETSNMP_FOUND)
    add_definitions(-DHAVE_LIBSNMP -DNET_SNMP -DHAVE_SNPRINT_OBJID)
endif()

### Compiler options

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CXX_DEFAULT_FLAGS # clang/GCC warnings
	$<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:GNU>>:-Wall;-Wextra;-Werror;-Wno-overloaded-virtual>
                         # MSVC warnings
    $<$<CXX_COMPILER_ID:MSVC>:/WX;/W4>)

add_definitions(-D__STDC_FORMAT_MACROS)

if(WIN32)
  #add_definitions(-DIN_LIBXML) # Enable for static build
  add_definitions(-DWIN32_LEAN_AND_MEAN)
endif()

### Install

if(APPLE)
  set(APP_ICON_FILE fwbuilder-macosx.icns)
  set(APP_ICON "${PROJECT_SOURCE_DIR}/src/gui/${APP_ICON_FILE}")
  set(APPLICATION_NAME fwbuilder)
  set(MACOSX_BUNDLE_ICON_FILE ${APP_ICON_FILE})
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_GENERATION})
  set(MACOSX_BUNDLE_VERSION ${VERSION})
  set(MACOSX_BUNDLE_LONG_VERSION_STRING ${VERSION})
  set_source_files_properties(${APP_ICON} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

  set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install")
  set(FWB_INSTALL_DATADIR ${APPLICATION_NAME}.app/Contents/Resources)
  set(FWB_INSTALL_DOCDIR ${FWB_INSTALL_DATADIR}/doc)
  set(FWB_INSTALL_BINDIR ${APPLICATION_NAME}.app/Contents/MacOS)
elseif(WIN32)
  set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR})
  set(FWB_INSTALL_DATADIR release/resources)
  set(FWB_INSTALL_DOCDIR release/doc)
  set(FWB_INSTALL_BINDIR release)
else()
  include(GNUInstallDirs)
  set(FWB_INSTALL_DATADIR ${CMAKE_INSTALL_DATADIR}/fwbuilder-${PROJECT_VERSION})
  set(FWB_INSTALL_DOCDIR ${CMAKE_INSTALL_DATADIR}/doc/fwbuilder-${PROJECT_VERSION})
  set(FWB_INSTALL_BINDIR ${CMAKE_INSTALL_BINDIR})
endif()

### Sources

add_subdirectory(src/libfwbuilder/src/fwcompiler)
add_subdirectory(src/libfwbuilder/src/fwbuilder)
add_subdirectory(src/common)
add_subdirectory(src/antlr)
add_subdirectory(src/compiler_lib)
add_subdirectory(src/cisco_lib)
add_subdirectory(src/juniper_lib)
add_subdirectory(src/pflib)
add_subdirectory(src/iptlib)
add_subdirectory(src/ipt)
add_subdirectory(src/pf)
add_subdirectory(src/ipf)
add_subdirectory(src/ipfw)
add_subdirectory(src/iosacl)
add_subdirectory(src/nxosacl)
add_subdirectory(src/junosacl)
add_subdirectory(src/pix)
add_subdirectory(src/procurve_acl)
add_subdirectory(src/libgui)
add_subdirectory(src/import)
add_subdirectory(src/parsers)
add_subdirectory(src/gui)
add_subdirectory(src/fwbedit)
add_subdirectory(src/libfwbuilder/etc)
add_subdirectory(src/libfwbuilder/migration)
add_subdirectory(src/res)
add_subdirectory(doc)
add_subdirectory(src/unit_tests)

### Packaging
add_subdirectory(packaging)

=== doc/CMakeLists.txt ===
FILE(GLOB readme_files "${CMAKE_CURRENT_SOURCE_DIR}/README.*")

install(FILES
        AUTHORS
        ChangeLog
        COPYING
        Credits
        FWBuilder-Routing-LICENSE.txt
        PatchAcceptancePolicy.txt
	${readme_files}
	DESTINATION ${FWB_INSTALL_DOCDIR})

if(UNIX AND NOT APPLE)
    FIND_PROGRAM(GZIP_TOOL
    	NAMES gzip
    	PATHS /bin
    	      /usr/bin
    	      /usr/local/bin)
    
    IF(NOT GZIP_TOOL)
        MESSAGE(FATAL_ERROR "Could not find gzip for man page compression.")
    endif(NOT GZIP_TOOL)
    
    add_custom_target(generate_man ALL
        COMMAND ${GZIP_TOOL} -c ${CMAKE_CURRENT_SOURCE_DIR}/fwbedit.1 > ${CMAKE_BINARY_DIR}/fwbedit.1.gz
        COMMAND ${GZIP_TOOL} -c ${CMAKE_CURRENT_SOURCE_DIR}/fwbuilder.1 > ${CMAKE_BINARY_DIR}/fwbuilder.1.gz
        COMMAND ${GZIP_TOOL} -c ${CMAKE_CURRENT_SOURCE_DIR}/fwb_iosacl.1 > ${CMAKE_BINARY_DIR}/fwb_iosacl.1.gz
        COMMAND ${GZIP_TOOL} -c ${CMAKE_CURRENT_SOURCE_DIR}/fwb_ipf.1 > ${CMAKE_BINARY_DIR}/fwb_ipf.1.gz
        COMMAND ${GZIP_TOOL} -c ${CMAKE_CURRENT_SOURCE_DIR}/fwb_ipfw.1 > ${CMAKE_BINARY_DIR}/fwb_ipfw.1.gz
        COMMAND ${GZIP_TOOL} -c ${CMAKE_CURRENT_SOURCE_DIR}/fwb_ipt.1 > ${CMAKE_BINARY_DIR}/fwb_ipt.1.gz
        COMMAND ${GZIP_TOOL} -c ${CMAKE_CURRENT_SOURCE_DIR}/fwb_pf.1 > ${CMAKE_BINARY_DIR}/fwb_pf.1.gz
        COMMAND ${GZIP_TOOL} -c ${CMAKE_CURRENT_SOURCE_DIR}/fwb_pix.1 > ${CMAKE_BINARY_DIR}/fwb_pix.1.gz)
    
    install(FILES ${CMAKE_BINARY_DIR}/fwbedit.1.gz
            ${CMAKE_BINARY_DIR}/fwbuilder.1.gz
            ${CMAKE_BINARY_DIR}/fwb_iosacl.1.gz
            ${CMAKE_BINARY_DIR}/fwb_ipf.1.gz
            ${CMAKE_BINARY_DIR}/fwb_ipfw.1.gz
            ${CMAKE_BINARY_DIR}/fwb_ipt.1.gz
            ${CMAKE_BINARY_DIR}/fwb_pf.1.gz
            ${CMAKE_BINARY_DIR}/fwb_pix.1.gz
            DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
endif(UNIX AND NOT APPLE)

=== packaging/CMakeLists.txt ===
set(CPACK_PACKAGE_VENDOR fwbuilder)
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_INSTALL_DIRECTORY fwbuilder)
set(CPACK_PACKAGE_EXECUTABLES fwbuilder fwbuilder)

if(APPLE)
  set(BUNDLE_DIR "\${CMAKE_INSTALL_PREFIX}/fwbuilder.app")
  set(BUNDLE_BIN_DIR "${BUNDLE_DIR}/Contents/MacOS")
  set(BUNDLE_FRAMEWORKS_DIR "${BUNDLE_DIR}/Contents/Frameworks")
  set(BUNDLE_PLUGINS_DIR "${BUNDLE_DIR}/Contents/PlugIns")
  set(MACDEPLOYQT_BIN "${_qt5Core_install_prefix}/bin/macdeployqt")

  install(CODE "
    EXECUTE_PROCESS(COMMAND ${MACDEPLOYQT_BIN} ${BUNDLE_DIR}
    -executable=${BUNDLE_BIN_DIR}/fwbedit
    -executable=${BUNDLE_BIN_DIR}/fwb_iosacl
    -executable=${BUNDLE_BIN_DIR}/fwb_ipt
    -executable=${BUNDLE_BIN_DIR}/fwb_ipf
    -executable=${BUNDLE_BIN_DIR}/fwb_ipfw
    -executable=${BUNDLE_BIN_DIR}/fwb_junosacl
    -executable=${BUNDLE_BIN_DIR}/fwb_nxosacl
    -executable=${BUNDLE_BIN_DIR}/fwb_procurve_acl
    -executable=${BUNDLE_BIN_DIR}/fwb_pf
    WORKING_DIRECTORY \"\${CMAKE_BINARY_DIR}\"
    OUTPUT_FILE macdeployqt-fwbuilder.log
    ERROR_FILE macdeployqt-fwbuilder.error)
    ")

  install(CODE "
    EXECUTE_PROCESS(COMMAND rm -rf
      ${BUNDLE_FRAMEWORKS_DIR}/QtQml.framework
      ${BUNDLE_FRAMEWORKS_DIR}/QtQuick.framework
      ${BUNDLE_FRAMEWORKS_DIR}/QtSvg.framework
      ${BUNDLE_FRAMEWORKS_DIR}/QtVirtualKeyboard.framework
      ${BUNDLE_PLUGINS_DIR}/virtualkeyboard
      ${BUNDLE_PLUGINS_DIR}/imageformats
    )
    ")

  set(CPACK_GENERATOR "DragNDrop")
  set(CPACK_DMG_FORMAT "UDBZ")
  set(CPACK_DMG_VOLUME_NAME fwbuilder)
  set(CPACK_PACKAGE_FILE_NAME fwbuilder-${PROJECT_VERSION})
elseif(WIN32)
configure_file(fwbuilder.nsi.in fwbuilder.nsi @ONLY)

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/fwbuilder.nsi
    fwbuilder-160x60.bmp
    fwbuilder-164x314.bmp
  DESTINATION ${CMAKE_INSTALL_PREFIX}/release)
endif()

include(CPack)

=== src/antlr/CMakeLists.txt ===
set(antlr_srcs
    ANTLRUtil.cpp 
    ASTFactory.cpp 
    ASTNULLType.cpp 
    ASTRefCount.cpp 
    BaseAST.cpp 
    BitSet.cpp 
    CharBuffer.cpp 
    CharScanner.cpp 
    CommonAST.cpp 
    CommonASTWithHiddenTokens.cpp 
    CommonHiddenStreamToken.cpp 
    CommonToken.cpp 
    InputBuffer.cpp 
    LLkParser.cpp 
    MismatchedCharException.cpp 
    MismatchedTokenException.cpp 
    NoViableAltException.cpp 
    NoViableAltForCharException.cpp 
    Parser.cpp 
    RecognitionException.cpp 
    String.cpp 
    TokenBuffer.cpp 
    Token.cpp 
    TokenRefCount.cpp 
    TokenStreamBasicFilter.cpp 
    TokenStreamHiddenTokenFilter.cpp 
    TokenStreamRewriteEngine.cpp 
    TokenStreamSelector.cpp 
    TreeParser.cpp)

add_library(antlr STATIC ${antlr_srcs})

target_include_directories(antlr PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>/..)

target_compile_options(antlr PRIVATE ${CXX_DEFAULT_FLAGS})

=== src/cisco_lib/CMakeLists.txt ===
set(cisco_lib_srcs
    PolicyCompiler_cisco.cpp
    PolicyCompiler_cisco_acls.cpp
    NamedObjectsAndGroupsSupport.cpp
    NamedObjectsManager.cpp
    NamedObjectsManagerNXOS.cpp
    NamedObjectsManagerIOS.cpp
    NamedObjectsManagerPIX.cpp
    RoutingCompiler_cisco.cpp
    RoutingCompiler_cisco_writers.cpp
    splitByNetworkZonesForRE.cpp
    specialServices.cpp
    ACL.cpp
    NamedObject.cpp
    ASA8TwiceNatLogic.cpp
    Helper.cpp
    inspectionProtocol.cpp
    inspectionClassMap.cpp
    OSConfigurator_nxos.cpp
    OSConfigurator_ios.cpp
    CompilerDriver_nxosacl.cpp
    CompilerDriver_nxosacl_run.cpp
    CompilerDriver_iosacl.cpp
    CompilerDriver_iosacl_run.cpp
    PolicyCompiler_nxosacl.cpp
    PolicyCompiler_nxosacl_writers.cpp
    PolicyCompiler_iosacl.cpp
    PolicyCompiler_iosacl_writers.cpp
    RoutingCompiler_nxosacl.cpp
    RoutingCompiler_nxosacl_writers.cpp
    RoutingCompiler_iosacl.cpp
    RoutingCompiler_iosacl_writers.cpp
    CompilerDriver_pix.cpp
    CompilerDriver_pix_run.cpp
    NATCompiler_pix.cpp
    NATCompiler_pix_find_translations.cpp
    NATCompiler_pix_writers.cpp
    NATCompiler_asa8.cpp
    NATCompiler_asa8_writers.cpp
    NATCompiler_pix_optimizers.cpp
    OSConfigurator_pix_os.cpp
    OSConfigurator_pix_os_fixups.cpp
    OSConfigurator_pix_os_inspectors.cpp
    OSConfigurator_pix_os_inspectors_pix8.cpp
    CompilerDriver_procurve_acl.cpp	
    CompilerDriver_procurve_acl_run.cpp
    OSConfigurator_procurve.cpp
    PolicyCompiler_procurve_acl.cpp
    PolicyCompiler_procurve_acl_writers.cpp
    RoutingCompiler_procurve_acl.cpp
    BaseObjectGroup.cpp
    PIXObjectGroup.cpp
    ASA8ObjectGroup.cpp
    NXOSObjectGroup.cpp
    IOSObjectGroup.cpp
    PolicyCompiler_pix.cpp
    PolicyCompiler_pix_writers.cpp
    PolicyCompiler_pix_v6_acls.cpp
    PolicyCompiler_pix_replace_translations.cpp
    RoutingCompiler_pix.cpp
    RoutingCompiler_pix_writers.cpp
    AutomaticRules_cisco.cpp
    AutomaticRules_iosacl.cpp
    AutomaticRules_nxosacl.cpp)

add_library(fwbcisco STATIC ${cisco_lib_srcs})

target_include_directories(fwbcisco PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>/..)

IF (UseQt6)
    target_link_libraries(fwbcisco compilerdriver Qt6::Core)
ELSE()
    target_link_libraries(fwbcisco compilerdriver Qt5::Core)
ENDIF()

target_compile_options(fwbcisco PRIVATE ${CXX_DEFAULT_FLAGS})

=== src/common/CMakeLists.txt ===
set(common_srcs
    init.cpp
    init2.cpp)

add_library(common STATIC ${common_srcs})

target_include_directories(common PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

IF (UseQt6)
    target_link_libraries(common fwbuilder Qt6::Core)
ELSE()
    target_link_libraries(common fwbuilder Qt5::Core)
ENDIF()

target_compile_options(common PRIVATE ${CXX_DEFAULT_FLAGS})

set_source_files_properties(init.cpp PROPERTIES COMPILE_DEFINITIONS PREFIX=\"${CMAKE_INSTALL_PREFIX}\")

=== src/compiler_lib/CMakeLists.txt ===
set(compiler_lib_srcs
    CompilerDriver.cpp
    CompilerDriver_files.cpp
    CompilerDriver_compile.cpp
    CompilerDriver_generators.cpp
    Configlet.cpp
    interfaceProperties.cpp
    linux24Interfaces.cpp
    openbsdInterfaces.cpp
    freebsdInterfaces.cpp
    nxosInterfaces.cpp
    iosInterfaces.cpp
    junosInterfaces.cpp
    procurveInterfaces.cpp
    pixInterfaces.cpp
    interfacePropertiesObjectFactory.cpp
    AutomaticRules.cpp)

add_library(compilerdriver STATIC ${compiler_lib_srcs})

target_include_directories(compilerdriver PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

IF (UseQt6)
    target_link_libraries(compilerdriver fwbuilder Qt6::Core)
ELSE()
    target_link_libraries(compilerdriver fwbuilder Qt5::Core)
ENDIF()

target_compile_options(compilerdriver PRIVATE ${CXX_DEFAULT_FLAGS})

=== src/fwbedit/CMakeLists.txt ===
find_package(OpenSSL REQUIRED)

set(fwbedit_srcs
    fwbedit.cpp
    new_object.cpp
    repair_tree.cpp
    list_object.cpp
    merge.cpp
    import.cpp
    ../libgui/FWBTree.cpp
    ../libgui/platforms.cpp)

add_executable(fwbedit ${fwbedit_srcs})

IF (UseQt6)
    target_link_libraries(fwbedit gui import fwbparser antlr common iptlib fwbpf fwbcisco compilerdriver fwcompiler fwbuilder xml2 m xslt z OpenSSL::Crypto pthread Qt6::Core Qt6::Widgets Qt6::PrintSupport)
ELSE()
    target_link_libraries(fwbedit gui import fwbparser antlr common iptlib fwbpf fwbcisco compilerdriver fwcompiler fwbuilder xml2 m xslt z OpenSSL::Crypto pthread Qt5::Core Qt5::Widgets Qt5::PrintSupport)
ENDIF()

IF (WIN32)
  target_link_libraries(fwbedit lzma iconv)
ENDIF()

IF (UNIX)
  target_link_libraries(fwbedit c ${CMAKE_DL_LIBS} util)
ENDIF()

IF (NETSNMP_FOUND)
  target_link_libraries(fwbedit netsnmp)
ENDIF()

target_compile_options(fwbedit PRIVATE ${CXX_DEFAULT_FLAGS})

set_source_files_properties(fwbedit.cpp PROPERTIES COMPILE_DEFINITIONS PREFIX=\"${CMAKE_INSTALL_PREFIX}\")

install(TARGETS fwbedit RUNTIME DESTINATION ${FWB_INSTALL_BINDIR})

=== src/gui/CMakeLists.txt ===
find_package(OpenSSL REQUIRED)

set(fwbuilder-gui_srcs
    main.cpp)

if(APPLE)
  set_source_files_properties(${APP_ICON_FILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  add_executable(fwbuilder-gui MACOSX_BUNDLE ${fwbuilder-gui_srcs} ${APP_ICON_FILE})
elseif(WIN32)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mwindows")
  add_executable(fwbuilder-gui ${fwbuilder-gui_srcs} fwbuilder-windows.rc)
else()
  add_executable(fwbuilder-gui ${fwbuilder-gui_srcs})
endif()

IF (UseQt6)
    target_link_libraries(fwbuilder-gui gui import fwbparser antlr common iptlib fwbpf fwbjuniper fwbcisco compilerdriver fwcompiler fwbuilder xml2 m xslt z OpenSSL::Crypto pthread Qt6::Core Qt6::Widgets Qt6::Network Qt6::PrintSupport)
ELSE()
    target_link_libraries(fwbuilder-gui gui import fwbparser antlr common iptlib fwbpf fwbjuniper fwbcisco compilerdriver fwcompiler fwbuilder xml2 m xslt z OpenSSL::Crypto pthread Qt5::Core Qt5::Widgets Qt5::Network Qt5::PrintSupport)
ENDIF()

IF (WIN32)
  target_link_libraries(fwbuilder-gui lzma iconv)
ENDIF()

IF (UNIX)
  target_link_libraries(fwbuilder-gui c ${CMAKE_DL_LIBS} util)
ENDIF()

IF (NETSNMP_FOUND)
  target_link_libraries(fwbuilder-gui netsnmp)
ENDIF()

target_compile_options(fwbuilder-gui PRIVATE ${CXX_DEFAULT_FLAGS})

set_target_properties(fwbuilder-gui PROPERTIES OUTPUT_NAME "fwbuilder")

if(APPLE)
  install(TARGETS fwbuilder-gui DESTINATION .)
else()
  install(TARGETS fwbuilder-gui DESTINATION ${FWB_INSTALL_BINDIR} COMPONENT Runtime)
endif()

=== src/import/CMakeLists.txt ===
set(import_srcs
    getProtoByName.cpp
    PreImport.cpp
    serviceObjectMaker.cpp
    objectMaker.cpp
    PIXImporter.cpp
    getServByName.cpp
    PIXImporterNat.cpp
    IPTImporterRun.cpp
    objectSignature.cpp
    Importer.cpp
    IPTImporter.cpp
    PFImporter.cpp
    PFImporterRun.cpp
    IOSImporterRun.cpp
    IOSImporter.cpp
    addressObjectMaker.cpp
    QStringListOperators.cpp
    PIXImporterRun.cpp)

add_library(import STATIC ${import_srcs})

target_include_directories(import PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

IF (UseQt6)
    target_link_libraries(import compilerdriver antlr Qt6::Core Qt6::Widgets)
ELSE()
    target_link_libraries(import compilerdriver antlr Qt5::Core Qt5::Widgets)
ENDIF()

target_compile_options(import PRIVATE ${CXX_DEFAULT_FLAGS})

=== src/iosacl/CMakeLists.txt ===
set(iosacl_srcs
    iosacl.cpp)

add_executable(fwb_iosacl ${iosacl_srcs})

IF (UseQt6)
    target_link_libraries(fwb_iosacl common fwbcisco compilerdriver fwcompiler fwbuilder xml2 pthread m xslt z Qt6::Core Qt6::Widgets)
ELSE()
    target_link_libraries(fwb_iosacl common fwbcisco compilerdriver fwcompiler fwbuilder xml2 pthread m xslt z Qt5::Core Qt5::Widgets)
ENDIF()

IF (WIN32)
  target_link_libraries(fwb_iosacl lzma iconv ws2_32)
ENDIF()

IF (UNIX)
  target_link_libraries(fwb_iosacl c ${CMAKE_DL_LIBS} util)
ENDIF()

target_compile_options(fwb_iosacl PRIVATE ${CXX_DEFAULT_FLAGS})

set_source_files_properties(iosacl.cpp PROPERTIES COMPILE_DEFINITIONS PREFIX=\"${CMAKE_INSTALL_PREFIX}\")

install(TARGETS fwb_iosacl RUNTIME DESTINATION ${FWB_INSTALL_BINDIR})

=== src/ipf/CMakeLists.txt ===
set(ipf_srcs
    ipf.cpp)

add_executable(fwb_ipf ${ipf_srcs})

IF (UseQt6)
    target_link_libraries(fwb_ipf common fwbpf compilerdriver fwcompiler fwbuilder xml2 pthread m xslt z Qt6::Core Qt6::Widgets)
ELSE()
    target_link_libraries(fwb_ipf common fwbpf compilerdriver fwcompiler fwbuilder xml2 pthread m xslt z Qt5::Core Qt5::Widgets)
ENDIF()

IF (WIN32)
  target_link_libraries(fwb_ipf lzma iconv ws2_32)
ENDIF()

IF (UNIX)
  target_link_libraries(fwb_ipf c ${CMAKE_DL_LIBS} util)
ENDIF()

target_compile_options(fwb_ipf PRIVATE ${CXX_DEFAULT_FLAGS})

set_source_files_properties(ipf.cpp PROPERTIES COMPILE_DEFINITIONS PREFIX=\"${CMAKE_INSTALL_PREFIX}\")

install(TARGETS fwb_ipf RUNTIME DESTINATION ${FWB_INSTALL_BINDIR})

=== debian/control ===
Source: fwbuilder
Section: net
Priority: optional
Maintainer: Sirius Bakke <sirius@bakke.co>
Build-Depends: debhelper (>=11~), cdbs, cmake, qtbase5-dev,
 qttools5-dev-tools, zlib1g-dev, libxml2-dev, libxslt1-dev, libsnmp-dev
Standards-Version: 3.9.3
Homepage: https://www.fwbuilder.org
Vcs-Browser: https://github.com/fwbuilder/fwbuilder
Vcs-Git: https://github.com/fwbuilder/fwbuilder.git

Package: fwbuilder
Architecture: any
Provides: fwbuilder-frontend
Depends: ${shlibs:Depends}, ${misc:Depends},  
 fwbuilder-common (= ${source:Version})
Replaces: fwbuilder-linux, fwbuilder-cisco, fwbuilder-bsd, fwbuilder-backend,
 libfwbuilder9
Recommends: fwbuilder-doc
Description: Firewall administration tool GUI
 Firewall Builder consists of an object-oriented GUI and a set of policy
 compilers for various firewall platforms. In Firewall Builder, firewall
 policy is a set of rules, each rule consists of abstract objects which
 represent real network objects and services (hosts, routers, firewalls,
 networks, protocols). Firewall Builder helps the user maintain a database
 of objects and allows policy editing using simple drag-and-drop operations.
 .
 This is the GUI part of fwbuilder

Package: fwbuilder-common
Depends: ${misc:Depends}
Architecture: all
Description: Firewall administration tool GUI (common files)
 Firewall Builder consists of an object-oriented GUI and a set of policy
 compilers for various firewall platforms. In Firewall Builder, firewall
 policy is a set of rules, each rule consists of abstract objects which
 represent real network objects and services (hosts, routers, firewalls,
 networks, protocols). Firewall Builder helps the user maintain a database
 of objects and allows policy editing using simple drag-and-drop operations.
 .
 This is the arch independent common parts of fwbuilder

Package: fwbuilder-doc
Depends: ${misc:Depends}
Section: doc
Architecture: all
Description: Firewall administration tool GUI documentation
 Firewall Builder consists of an object-oriented GUI and a set of policy
 compilers for various firewall platforms. In Firewall Builder, firewall
 policy is a set of rules, each rule consists of abstract objects which
 represent real network objects and services (hosts, routers, firewalls,
 networks, protocols). Firewall Builder helps the user maintain a database
 of objects and allows policy editing using simple drag-and-drop operations.
 .
 This is the documentation of fwbuilder

Package: fwbuilder-dbg
Section: debug
Priority: extra
Architecture: any
Depends: fwbuilder (= ${binary:Version}), ${misc:Depends}
Description: Firewall administration tool GUI (debugging symbols)
 Firewall Builder consists of an object-oriented GUI and a set of policy
 compilers for various firewall platforms. In Firewall Builder, firewall
 policy is a set of rules, each rule consists of abstract objects which
 represent real network objects and services (hosts, routers, firewalls,
 networks, protocols). Firewall Builder helps the user maintain a database
 of objects and allows policy editing using simple drag-and-drop operations.
 .
 This package ships the debugging symbols of fwbuilder.
